from mesa.time import BaseScheduler

from firm import FirmAgent
from product import ProductAgent


class CustomScheduler(BaseScheduler):
    def __init__(self, model):
        super().__init__(model)
        self.company_agents = []
        self.product_agents = []

    def add_agent(self, agent):
        if isinstance(agent, FirmAgent):
            self.company_agents.append(agent)
        elif isinstance(agent, ProductAgent):
            self.product_agents.append(agent)
        super().add_agent(agent)

    def step(self):
        # First, activate all company agents
        for agent in self.company_agents:
            agent.step()

        # Then, activate all product agents
        for agent in self.product_agents:
            agent.step()
